I don't consider myself good in DS&A puzzles. My definition of good in DS&A puzzles is basically you can solve common/most Hard Leetcode problems in under 45 mins. I think if you can do this you'll have no problem jumping ship of FAANG-league companies every year. I am still not in FAANG.
My skill now is pretty much in Medium Leetcode problems, which I can solve common/most of them in under 45 mins. I used to be worse at this and couldn't even solve Easy problems for 2 hours. I just practiced and practiced and studied, until it becomes easier.
Now, what this skill gives me is, I can easily knock off majority of non FAANG interviews out there, in under 30 mins. In my last interviewing with companies I actually did most of their questions each in under 15 mins. This leaves them to talk about something else such as projects, past responsibilities, cultural fit, or even just dismiss the interview altogether to save everyone time.
DS&A interview is in a sense, sort of a pair programming/discussion thing because you need to voice your reasoning out loud to check with the interviewer that you are going in the right direction.
Also once you practiced these kinds of questions, then it is no longer "I need to find a new solution to this problem", but more "ah I see this question before and I know how to solve this". It is pretty much almost brain-dead at this moment. Like, dynamic programming, recursion, and BFS/DFS are pretty much very mechanical. Once you've seen a few patterns, then you can tackle most of it.
Yes this skill doesn't come easily, but once you get it, you get it. So the difficulty of attaining this skill is overrated. It is like swimming and driving. Once you get it, it takes a few weeks to ramp up again. Weighing the pros and cons of DS&A compared to other style of interviews, it is clear to me which is the winner to optimize my happiness and lessen my sufferings. It is cheap to execute, it works majority of the time.
If a software engineer realize this reality and start playing the game, he/she is already ahead in the curve by a few miles from other candidates.
Ironically, I actually don't want most software engineers to realize this, because this skill currently gives me an advantage. If everyone start doing this, then the interview bar will be raised higher and we as an industry will see other practices which are optimized for software engineering candidates suffering.
but if DS&A puzzles are a de-facto standard, why not have an actual standard? the whole thing is pretty haphazard.
it's like hiring someone to be your defense attorney because they're decent at the NYT Crossword Puzzle, or to be your doctor because they're good at Sudoku.
This game is actually really easy to play, much easier than any other corporate/job game in other fields. You just need to know the rules, study the rules and get on with your life. You don't need bachelor/master from expensive universities or any other gate-keeping bst like in medical or law.
I wasn't born rich or smart or have good connections, and I'm glad setting aside a few months to study DS&A can make me earn what most Americans or the world envy. Much more if I'm good at it so I can jump ship at FAANG every year and living the dream. Let the rich/smart/well-connected people solve harder problems such as medicine or law. I just get on with my life.